DAEMON(3)

NAME
daemon - run in the background

SYNOPSIS
#include <stdlib.h>
int
daemon(int nochdir, int noclose);

DESCRIPTION
The daemon() function is for programs wishing to detach themselves from the controlling terminal and run in the background as system daemons.

If the argument nochdir is zero, daemon() changes the current working directory to the root (/).

If the argument noclose is zero, daemon() redirects standard input, standard output and standard error to /dev/null.

RETURN VALUES
Upon success, daemon() returns 0; otherwise -1 is returned.

ERRORS
The function daemon() may fail and set errno for any of the errors specified for the library functions fork(2) and setsid(2).

SEE ALSO
fork(2), setsid(2)

HISTORY
The daemon() function first appeared in 4.4BSD.

CAVEATS
If the noclose argument is zero, daemon() closes the first three file descriptors and redirects them to /dev/null. Normally, these correspond to standard input, standard output and standard error. However, if any of those file descriptors refer to something else they will still be closed, resulting in incorrect behavior of the calling program. This can happen if any of standard input, standard output or standard error have been closed before the program was run. Programs using daemon() should therefore make sure to either call daemon() before opening any files or sockets or, alternately, verifying that any file descriptors obtained have a value greater than 2.